def checkpoint(queue, iteration, save=True):
    if save is True:
        print("Saving checkpoint!", end="\r")
        import pickle
        import sys
        sys.setrecursionlimit(2000)

        all_jobs = queue.all()

        for job in all_jobs:
            if job.assertion_job is not None:
                all_jobs.append(job.assertion_job)
        # Save the communicator
        communicator = all_jobs[0].communicator
        # vault = all_jobs[0].vault
        for job in all_jobs:
            job.communicator = None
            # vault = None

        to_save = [queue, iteration]
        # Dump object
        pickle.dump(to_save, open("checkpoint.pkl", "wb"))

        # Restore the communicator
        for job in all_jobs:
            job.communicator = communicator
            # job.vault = vault
        # print("Vault!:\n", all_jobs[0].vault)
        print("Checkpoint saved!")


def recover_checkpoint(communicator, vault=None, filename="checkpoint.pkl"):
    import pickle as pkl
    print("Loading checkpoint!", end="\r")
    queue, iteration = pkl.load(open(filename, "rb"))
    all_jobs = queue.all()
    for job in all_jobs:
        job.communicator = communicator
        if vault:
            job.vault = vault
    job_with_no_parent = [job for job in all_jobs if job.parent is None]
    grandfather = job_with_no_parent[0]
    print("Checkpoint loaded!!")
    return queue, grandfather, iteration


def saving_state(_queue, filename="state.pkl"):
    import pickle as pkl
    possible_states = ["PENDING", "RUNNING", "ASSERTION_PENDING", "SUCCESS", "FAILED", "SUSPENDED"]
    log = {}
    for state in possible_states:
        log[state] = []

    for job in _queue.all():
        log[job.status].append(job.identifier())

    with open(filename, "wb") as output_log:
        pkl.dump(log, output_log, protocol=2)



